#include "stdafx.h"
#include "BluetoothManger.h"


CBluetoothManger::CBluetoothManger()
{
	FindRadios();
}


CBluetoothManger::~CBluetoothManger()
{
	for_each(m_vecRadios.begin(), m_vecRadios.end(), [](CBluetoothRadioManager *pCBluetoothRadioManager) { delete pCBluetoothRadioManager; });
	m_vecRadios.clear();
}

void CBluetoothManger::FindRadios(void)
{
	BLUETOOTH_FIND_RADIO_PARAMS btfrp = { sizeof(btfrp), };
	HANDLE hRadio = NULL;

	HBLUETOOTH_RADIO_FIND hFind = BluetoothFindFirstRadio(&btfrp, &hRadio);

	if (hFind == NULL)
		return;

	do
	{
		try
		{
			m_vecRadios.push_back(new CBluetoothRadioManager(hRadio));
		}
		catch (...)
		{
			TRACE(_T("try-catch : new CBluetoothRadioManager"));
		}
		
	} while (BluetoothFindNextRadio(hFind, &hRadio));

	BluetoothFindRadioClose(hFind);
}

size_t CBluetoothManger::GetRadioSize(void)
{
	return m_vecRadios.size();
}

CBluetoothRadioManager *CBluetoothManger::GetRadio(size_t pos)
{
	return m_vecRadios[pos];
}

CBluetoothRadioManager *CBluetoothManger::GetRadio(LPCTSTR pszName)
{
	for (auto itor = m_vecRadios.begin(); itor != m_vecRadios.end(); ++itor)
	{
		if (_tcscmp((*itor)->GetName(), pszName) == 0)
			return *itor;
	}

	return NULL;
}
