// BluetoothRadioManager.cpp :  Դϴ.
//

#include "stdafx.h"
#include "BluetoothRadioManager.h"


// CBluetoothRadioManager

IMPLEMENT_DYNAMIC(CBluetoothRadioManager, CWnd)

CBluetoothRadioManager::CBluetoothRadioManager(HANDLE hRadioHandle) : 
m_hRadio(hRadioHandle),
m_hNotification(NULL),
m_BLUETOOTH_RADIO_INFO({ sizeof(m_BLUETOOTH_RADIO_INFO), }),
m_Socket(std::bind(&CBluetoothRadioManager::OnAccept, this, std::placeholders::_1))
{
	if (hRadioHandle == NULL)
		throw;

	CString strMyClass = AfxRegisterWndClass(CS_VREDRAW | CS_HREDRAW,
		::LoadCursor(NULL, IDC_ARROW), (HBRUSH) ::GetStockObject(WHITE_BRUSH),
		::LoadIcon(NULL, IDI_APPLICATION));

	this->CreateEx(NULL, strMyClass, _T("CBluetoothRadioManager"), NULL, CRect(0, 0, 0, 0), NULL, NULL);
	
	RefreshInfo();

	StartNotification();

	FindDevice();
}

CBluetoothRadioManager::~CBluetoothRadioManager()
{
	ReleaseDevice();

	::CloseHandle(m_hRadio);

	this->DestroyWindow();
}


BEGIN_MESSAGE_MAP(CBluetoothRadioManager, CWnd)
	ON_WM_DEVICECHANGE()
END_MESSAGE_MAP()


// CBluetoothRadioManager ޽ óԴϴ.


BOOL CBluetoothRadioManager::StartNotification(void)
{
	DEV_BROADCAST_HANDLE NotificationFilter = { sizeof(NotificationFilter), };

	NotificationFilter.dbch_devicetype = DBT_DEVTYP_HANDLE;
	NotificationFilter.dbch_handle = m_hRadio;
	//NotificationFilter.dbch_eventguid = GUID_BLUETOOTH_RADIO_IN_RANGE;
	NotificationFilter.dbch_eventguid = GUID_BTHPORT_DEVICE_INTERFACE;	

	m_hNotification = RegisterDeviceNotification(GetSafeHwnd(), &NotificationFilter, DEVICE_NOTIFY_WINDOW_HANDLE);

	if (m_hNotification == NULL)
	{
		std::wcout << _T("failed RegisterDeviceNotification! : ") << WSAGetLastError() << std::endl;
		return FALSE;
	}

	std::wcout << _T("Register Device Notification! : ") << m_hNotification << std::endl;
	return TRUE;	
}

BOOL CBluetoothRadioManager::OnDeviceChange(UINT nEventType, DWORD_PTR dwData)
{
	switch (nEventType)
	{
	case DBT_CONFIGCHANGECANCELED:
		std::wcout << _T("A request to change the current configuration(dock or undock) has been canceled.") << std::endl;
		break;
	case DBT_CONFIGCHANGED:
		std::wcout << _T("The current configuration has changed, due to a dock or undock.") << std::endl;
		break;
	case DBT_DEVICEARRIVAL:
		std::wcout << _T("A device or piece of media has been inserted and is now available.") << std::endl;
		break;
	case DBT_DEVICEQUERYREMOVE:
		std::wcout << _T("Permission is requested to remove a device or piece of media.Any application can deny this request and cancel the removal.") << std::endl;
		break;
	case DBT_DEVICEQUERYREMOVEFAILED:
		std::wcout << _T("A request to remove a device or piece of media has been canceled.") << std::endl;
		break;
	case DBT_DEVICEREMOVECOMPLETE:
		std::wcout << _T("A device or piece of media has been removed.") << std::endl;
		break;
	case DBT_DEVICEREMOVEPENDING:
		std::wcout << _T("A device or piece of media is about to be removed.Cannot be denied.") << std::endl;
		break;
	case DBT_DEVICETYPESPECIFIC:
		std::wcout << _T("A device - specific event has occurred.") << std::endl;
		break;
	case DBT_DEVNODES_CHANGED:
		std::wcout << _T("A device has been added to or removed from the system.") << std::endl;
		break;
	case DBT_QUERYCHANGECONFIG:
		std::wcout << _T("Permission is requested to change the current configuration(dock or undock).") << std::endl;
		break;
	case DBT_USERDEFINED:
		std::wcout << _T("The meaning of this message is user - defined.") << std::endl;
		break;
	case DBT_CUSTOMEVENT:
	{
		_DEV_BROADCAST_USERDEFINED *pData = reinterpret_cast<_DEV_BROADCAST_USERDEFINED*>(dwData);

		PDEV_BROADCAST_HDR pHeader = reinterpret_cast<PDEV_BROADCAST_HDR>(&pData->dbud_dbh);
		if (pHeader->dbch_devicetype != DBT_DEVTYP_HANDLE)
			throw;

		PDEV_BROADCAST_HANDLE pHandle = reinterpret_cast<PDEV_BROADCAST_HANDLE>(pHeader);

		if (pHandle->dbch_eventguid == GUID_BLUETOOTH_RADIO_IN_RANGE)
		{
			PBTH_RADIO_IN_RANGE pRadioInfo = reinterpret_cast<PBTH_RADIO_IN_RANGE>(pHandle->dbch_data);
			BTH_DEVICE_INFO *pDeviceInfo = &pRadioInfo->deviceInfo;

			//std::wcout << _T("/// before flag start ///") << std::endl;

			//std::wcout << _T("BDIF_ADDRESS : ") << (pRadioInfo->previousDeviceFlags&BDIF_ADDRESS) << std::endl;
			//std::wcout << _T("BDIF_COD : ") << (pRadioInfo->previousDeviceFlags&BDIF_COD) << std::endl;
			//std::wcout << _T("BDIF_NAME : ") << (pRadioInfo->previousDeviceFlags&BDIF_NAME) << std::endl;
			//std::wcout << _T("BDIF_PAIRED : ") << (pRadioInfo->previousDeviceFlags&BDIF_PAIRED) << std::endl;
			//std::wcout << _T("BDIF_PERSONAL : ") << (pRadioInfo->previousDeviceFlags&BDIF_PERSONAL) << std::endl;
			//std::wcout << _T("BDIF_CONNECTED : ") << (pRadioInfo->previousDeviceFlags&BDIF_CONNECTED) << std::endl;
			//std::wcout << _T("BDIF_SSP_SUPPORTED : ") << (pRadioInfo->previousDeviceFlags&BDIF_SSP_SUPPORTED) << std::endl;
			//std::wcout << _T("BDIF_SSP_PAIRED : ") << (pRadioInfo->previousDeviceFlags&BDIF_SSP_PAIRED) << std::endl;
			//std::wcout << _T("BDIF_SSP_MITM_PROTECTED : ") << (pRadioInfo->previousDeviceFlags&BDIF_SSP_MITM_PROTECTED) << std::endl;

			//std::wcout << _T("/// before flag end ///") << std::endl;

			//std::wcout << _T("/// after flag start ///") << std::endl;

			//std::wcout << _T("BDIF_ADDRESS : ") << (pDeviceInfo->flags&BDIF_ADDRESS) << std::endl;
			//std::wcout << _T("BDIF_COD : ") << (pDeviceInfo->flags&BDIF_COD) << std::endl;
			//std::wcout << _T("BDIF_NAME : ") << (pDeviceInfo->flags&BDIF_NAME) << std::endl;
			//std::wcout << _T("BDIF_PAIRED : ") << (pDeviceInfo->flags&BDIF_PAIRED) << std::endl;
			//std::wcout << _T("BDIF_PERSONAL : ") << (pDeviceInfo->flags&BDIF_PERSONAL) << std::endl;
			//std::wcout << _T("BDIF_CONNECTED : ") << (pDeviceInfo->flags&BDIF_CONNECTED) << std::endl;
			//std::wcout << _T("BDIF_SSP_SUPPORTED : ") << (pDeviceInfo->flags&BDIF_SSP_SUPPORTED) << std::endl;
			//std::wcout << _T("BDIF_SSP_PAIRED : ") << (pDeviceInfo->flags&BDIF_SSP_PAIRED) << std::endl;
			//std::wcout << _T("BDIF_SSP_MITM_PROTECTED : ") << (pDeviceInfo->flags&BDIF_SSP_MITM_PROTECTED) << std::endl;

			//std::wcout << _T("/// after flag end ///") << std::endl;

			//std::wcout << _T("GUID_BLUETOOTH_RADIO_IN_RANGE : ") << pRadioInfo->deviceInfo.address << std::endl;
			//std::wcout << _T("GUID_BLUETOOTH_RADIO_IN_RANGE : ") << pRadioInfo->deviceInfo.classOfDevice << std::endl;
			//std::wcout << _T("GUID_BLUETOOTH_RADIO_IN_RANGE : ") << pRadioInfo->deviceInfo.name << std::endl;

			BOOL bOldDevice = FALSE;
			auto ramda_Attach = [&bOldDevice, &pDeviceInfo](CBluetoothDeviceManager *pCBluetoothDeviceManager)->void
			{
				bOldDevice |= pCBluetoothDeviceManager->Attach(*pDeviceInfo);
			};

			for_each(m_vecDevices.begin(), m_vecDevices.end(), ramda_Attach);
			
			if (!bOldDevice && (pDeviceInfo->flags&BDIF_NAME))
			{
				try
				{
					BLUETOOTH_DEVICE_INFO_STRUCT DeviceInfo = { sizeof(DeviceInfo), };
					_tcscpy_s(DeviceInfo.szName, CA2T(pDeviceInfo->name));
					DeviceInfo.Address.ullLong = pDeviceInfo->address;
					DeviceInfo.ulClassofDevice = pDeviceInfo->classOfDevice;

					CBluetoothDeviceManager *pCBluetoothDeviceManager = new CBluetoothDeviceManager(*this, DeviceInfo);
					if (pCBluetoothDeviceManager->Attach(*pDeviceInfo))
						m_vecDevices.push_back(pCBluetoothDeviceManager);
				}
				catch (...)
				{
					TRACE(_T("try-catch : new CBluetoothDeviceManager"));
				}
			}
		}
		else if (pHandle->dbch_eventguid == GUID_BLUETOOTH_L2CAP_EVENT)
		{
			PBTH_L2CAP_EVENT_INFO pL2CAPEvent = reinterpret_cast<PBTH_L2CAP_EVENT_INFO>(pHandle->dbch_data);

			std::wcout << _T("GUID_BLUETOOTH_L2CAP_EVENT bthAddress : ") << pL2CAPEvent->bthAddress << std::endl;
			std::wcout << _T("GUID_BLUETOOTH_L2CAP_EVENT psm : ") << pL2CAPEvent->psm << std::endl;
			std::wcout << _T("GUID_BLUETOOTH_L2CAP_EVENT connected : ") << pL2CAPEvent->connected << std::endl;
			std::wcout << _T("GUID_BLUETOOTH_L2CAP_EVENT initiated : ") << pL2CAPEvent->initiated << std::endl;

			// Connect Try
			if (pL2CAPEvent->connected)
			{				
				CBluetoothDeviceManager *pCBluetoothDeviceManager = GetDevice(pL2CAPEvent->bthAddress);

				// Device -> PC Connect Try
				if (pL2CAPEvent->initiated == 0 && pCBluetoothDeviceManager != NULL)
				{
				}
				// PC -> Device Connect Try
				else if (pL2CAPEvent->initiated != 0 && pCBluetoothDeviceManager != NULL)
				{
				}
			}
		}
		else if (pHandle->dbch_eventguid == GUID_BLUETOOTH_RADIO_OUT_OF_RANGE)
		{
			BLUETOOTH_ADDRESS *pBAdd = reinterpret_cast<BLUETOOTH_ADDRESS*>(pHandle->dbch_data);

			std::wcout << _T("GUID_BLUETOOTH_RADIO_OUT_OF_RANGE BLUETOOTH_ADDRESS : ") << pBAdd->ullLong << std::endl;

			CBluetoothDeviceManager *pCBluetoothDeviceManager = GetDevice(pBAdd->ullLong);
			
			if (pCBluetoothDeviceManager != NULL)
			{
			}
		}
		else if (pHandle->dbch_eventguid == GUID_BLUETOOTH_AUTHENTICATION_REQUEST)
		{
			std::wcout << _T("GUID_BLUETOOTH_AUTHENTICATION_REQUEST") << std::endl;
		}
		else if (pHandle->dbch_eventguid == GUID_BLUETOOTH_HCI_EVENT)
		{
			BTH_HCI_EVENT_INFO *pHCIEvent;
			pHCIEvent = (BTH_HCI_EVENT_INFO *)pHandle->dbch_data;

			switch (pHCIEvent->connectionType)
			{
			case HCI_CONNECTION_TYPE_ACL:
				break;
			case HCI_CONNECTION_TYPE_SCO:
				break;
			default:
				throw;
			}

			if (pHCIEvent->connected)
				std::wcout << _T("GUID_BLUETOOTH_HCI_EVENT : Connected") << std::endl;
			else
				std::wcout << _T("GUID_BLUETOOTH_HCI_EVENT : Disconnected") << std::endl;

			CBluetoothDeviceManager *pCBluetoothDeviceManager = GetDevice(pHCIEvent->bthAddress);
						
			if (pCBluetoothDeviceManager != NULL)
			{
				if (pHCIEvent->connected == FALSE)
				{

				}
				else if (pHCIEvent->connected)
				{

				}
			}

			std::wcout << _T("GUID_BLUETOOTH_HCI_EVENT : ") << pHCIEvent->bthAddress << std::endl;
		}
		else
		{
			TCHAR buf[128] = { NULL, };			
			StringFromGUID2(pHandle->dbch_eventguid, buf, 128);

			std::wcout << _T("NOT DEFINED EVENTGUID : ") << buf << std::endl;
		}
		break;
	}
	default:
	{
		std::wcout << _T("NOT DEFINED EVENTTYPE : ") << nEventType << std::endl;
		break;
	}
	}

	return FALSE;
}

BOOL CBluetoothRadioManager::OnAccept(SOCKET s)
{
	SOCKADDR_BTH SockAddrBthLocal = { 0 };
	SockAddrBthLocal.addressFamily = AF_BTH;
	SockAddrBthLocal.serviceClassId = SerialPortServiceClass_UUID;
	SockAddrBthLocal.port = BT_PORT_ANY;
	int len = sizeof(SockAddrBthLocal);

	if (getpeername(s, (struct sockaddr *)&SockAddrBthLocal, &len) == SOCKET_ERROR)
	{
		std::wcout << _T("getpeername is Faile : ") << WSAGetLastError() << std::endl;
		
		return FALSE;
	}

	CBluetoothDeviceManager *pCBluetoothDeviceManager = GetDevice(SockAddrBthLocal.btAddr);

	if (pCBluetoothDeviceManager == NULL)
		return FALSE;

	return pCBluetoothDeviceManager->SocketAttach(s);
}

BOOL CBluetoothRadioManager::RefreshInfo(void)
{
	ZeroMemory(&m_BLUETOOTH_RADIO_INFO, sizeof(m_BLUETOOTH_RADIO_INFO));
	m_BLUETOOTH_RADIO_INFO.dwSize = sizeof(m_BLUETOOTH_RADIO_INFO);

	DWORD dwResult = BluetoothGetRadioInfo(m_hRadio, &m_BLUETOOTH_RADIO_INFO);

	if (dwResult != ERROR_SUCCESS)
	{
		std::wcerr << _T("BluetoothGetRadioInfo failed with error code : ") << WSAGetLastError() << std::endl;
		return FALSE;
	}

	std::wcout << _T("BluetoothGetRadioInfo is OK!") << std::endl;
	return TRUE;
}

void CBluetoothRadioManager::ReleaseDevice(void)
{
	for_each(m_vecDevices.begin(), m_vecDevices.end(), [](CBluetoothDeviceManager *pCBluetoothDeviceManager) { delete pCBluetoothDeviceManager; });
	m_vecDevices.clear();
}

void CBluetoothRadioManager::FindDevice(void)
{
	ReleaseDevice();

	BLUETOOTH_DEVICE_INFO_STRUCT deviceInfo = { sizeof(deviceInfo), };
	BLUETOOTH_DEVICE_SEARCH_PARAMS deviceSearchParams = { sizeof(deviceSearchParams), };

	deviceSearchParams.cTimeoutMultiplier = 5;  //5*1.28s search timeout
	deviceSearchParams.fIssueInquiry = true;    //new inquiry
	deviceSearchParams.fReturnAuthenticated = TRUE;
	deviceSearchParams.fReturnRemembered = TRUE;
	deviceSearchParams.fReturnUnknown = TRUE;
	deviceSearchParams.fReturnConnected = TRUE;
	deviceSearchParams.hRadio = m_hRadio;

	HBLUETOOTH_DEVICE_FIND hDeviceFind = BluetoothFindFirstDevice(&deviceSearchParams, &deviceInfo);

	if (hDeviceFind == NULL)
		return;

	do
	{
		try
		{			
			m_vecDevices.push_back(new CBluetoothDeviceManager(*this, deviceInfo));
		}
		catch (...)
		{
			TRACE(_T("try-catch : new CBluetoothDeviceManager"));
		}
	} while (BluetoothFindNextDevice(hDeviceFind, &deviceInfo));

	BluetoothFindDeviceClose(hDeviceFind);
}

BLUETOOTH_ADDRESS CBluetoothRadioManager::GetAddress(void)
{
	RefreshInfo();

	return m_BLUETOOTH_RADIO_INFO.address;
}

LPCTSTR CBluetoothRadioManager::GetName(void)
{
	RefreshInfo();

	return m_BLUETOOTH_RADIO_INFO.szName;
}

ULONG CBluetoothRadioManager::GetClassofDevice(void)
{
	RefreshInfo();

	return m_BLUETOOTH_RADIO_INFO.ulClassofDevice;
}

size_t CBluetoothRadioManager::GetDeviceSize(void)
{
	return m_vecDevices.size();
}

CBluetoothDeviceManager *CBluetoothRadioManager::GetDevice(size_t pos)
{
	return m_vecDevices[pos];
}

CBluetoothDeviceManager *CBluetoothRadioManager::GetDevice(LPCTSTR pszName)
{
	for (auto itor = m_vecDevices.begin(); itor != m_vecDevices.end(); ++itor)
	{
		if (_tcscmp((*itor)->GetName(), pszName) == 0)
			return *itor;
	}

	return NULL;
}

CBluetoothDeviceManager *CBluetoothRadioManager::GetDevice(BTH_ADDR &rBTH_ADDR)
{
	for (auto itor = m_vecDevices.begin(); itor != m_vecDevices.end(); ++itor)
	{
		if ((*itor)->GetAddress().ullLong == rBTH_ADDR)
			return *itor;
	}

	return NULL;
}