#pragma once

#include <BluetoothAPIs.h>
#include <dbt.h>

#include <iostream>

#include <vector>
#include <algorithm>

#include "BluetoothDeviceManager.h"

// CBluetoothRadioManager

class CBluetoothDeviceManager;

class CBluetoothRadioManager : public CWnd
{
	DECLARE_DYNAMIC(CBluetoothRadioManager)

public:
	CBluetoothRadioManager(HANDLE hRadioHandle);
	virtual ~CBluetoothRadioManager();

protected:
	DECLARE_MESSAGE_MAP()

private:
	friend class CBluetoothDeviceManager;
	
	HANDLE m_hRadio;
	HDEVNOTIFY m_hNotification;	
	BLUETOOTH_RADIO_INFO m_BLUETOOTH_RADIO_INFO;

	CBluetoothSocketListener m_Socket;	

	std::vector<CBluetoothDeviceManager*> m_vecDevices;

	BOOL StartNotification(void);
	BOOL RefreshInfo(void);

	void ReleaseDevice(void);
	void FindDevice(void);

protected:
	afx_msg BOOL OnDeviceChange(UINT nEventType, DWORD_PTR dwData);
	virtual BOOL OnAccept(SOCKET s);

public:
	BLUETOOTH_ADDRESS GetAddress(void);
	LPCTSTR GetName(void);
	ULONG GetClassofDevice(void);

	size_t GetDeviceSize(void);
	CBluetoothDeviceManager *GetDevice(size_t pos);
	CBluetoothDeviceManager *GetDevice(LPCTSTR pszName);
	CBluetoothDeviceManager *GetDevice(BTH_ADDR &rBTH_ADDR);
};


